:-module(prim_ports,[prim_openPort/3,prim_basicServerLoop/4,prim_sendPort/5,prim_after/4,prim_openProcessPort/2,prim_ping/3,prim_timeoutOnStream/5,prim_openPortOnSocket/3,prim_connectPortAtSocket/4,prim_choiceSPEP/5,checkIncomingPortStreams/3,ifTracePort/1,readPortMessage/4,parse_received_message/4]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(prim_standard)->true;ensure_loaded(user:prim_standard).
:-current_module(prim_readshowterm)->true;use_module(prim_readshowterm).
:-dynamic only_localhost/1,tracePorts/1,mySocket/1,incomingPortStreams/2.
only_localhost(_3156):-(getEnv('PAKCS_LOCALHOST',_3162)->true;_3162=no),(_3162=yes->asserta(only_localhost(yes)),_3156=yes;asserta(only_localhost(no)),_3156=no),retract((only_localhost(_3242):-_3246,_3248)),!.
tracePorts(unknown).
ifTracePort(_3340):-tracePorts(_3344),(_3344=unknown->retract(tracePorts(_3354)),(getEnv('PAKCS_TRACEPORTS',_3364)->true;_3364=no),(_3364=yes->asserta(tracePorts(yes)),_3340;asserta(tracePorts(no)));_3344=yes->_3340;true).
prim_openPort(_3508,_3510,_3512):-nonvar(_3508),!,writeErr('ERROR: openPort: port is not a free variable'),nlErr,fail.
prim_openPort(_3598,_3600,_3602):-nonvar(_3600),!,writeErr('ERROR: openPort: stream is not a free variable'),nlErr,fail.
prim_openPort('Ports.internalPort'([],0,0,_3694),_3694,'Prelude.True').
prim_openPortOnSocket(_3744,_3746,_3748):-(retract(mySocket('Ports.internalPort'(_3752,_3754,_3756,_3758)))->_3776 is _3756+1,asserta(mySocket('Ports.internalPort'(_3752,_3754,_3776,_3758))),(_3744=_3754,_3746=_3776->true;writeErr('ERROR: inconsistent socket/port numbers in openPortOnSocket!'),nlErr);trySetSocketNumber(_3744),on_exception(_3882,listenOnNewSocket(_3744,_3864,_3758),(write('ERROR: openPortOnSocket "'),write(_3744),write('":'),nl,printError(_3882),!,fail)),atom2String(_3864,_3752),(var(_3746)->_3746=0;true),asserta(mySocket('Ports.internalPort'(_3752,_3744,_3746,_3758)))),mySocket(_4006),_4006='Ports.internalPort'(_4010,_4012,_4014,_4016),ifTracePort((writeErr('TRACEPORTS: Listen on port '),writeErr(_4014),writeErr(' at socket '),writeErr(_4012),writeErr(' on host '),(only_localhost(yes)->writeErr(localhost);string2Atom(_4010,_4062),writeErr(_4062)),writeErr(...),nlErr)),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4006),_3748);_3748='Ports.basicServerLoop'(_4006)).
trySetSocketNumber(_4242):-var(_4242),getEnv('PAKCS_SOCKET',_4252),atom_codes(_4252,_4258),number_codes(_4242,_4258),!.
trySetSocketNumber(_4326).
prim_basicServerLoop(_4630,_4632,_4634,_4636):-freeze(_4634,blocked_prim_basicServerLoop(_4630,_4632,_4634,_4636)).
blocked_prim_basicServerLoop(_4698,_4700,_4702,_4704):-readPort(_4698,_4710,-1),_4700=[_4710|_4718],(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_4698),_4718);_4718='Ports.basicServerLoop'(_4698)),_4702=_4704.
prim_timeoutOnStream(_5126,_5128,_5130,_5132,_5134):-freeze(_5132,blocked_prim_timeoutOnStream(_5126,_5128,_5130,_5132,_5134)).
blocked_prim_timeoutOnStream(_5204,_5206,_5208,_5210,_5212):-user:derefRoot(_5204,_5218),prim_timeoutOnStream_exec(_5218,_5206,_5208,_5210,_5212).
prim_timeoutOnStream_exec(_5312,_5314,'Prelude.Nothing',_5318,_5320):-var(_5314),!,_5318=_5320.
prim_timeoutOnStream_exec(_5416,share(_5412),_5420,_5422,_5424):-!,get_mutable(_5428,_5412),(_5428='$eval'(_5434)->_5420=_5434,_5422=_5424;prim_timeoutOnStream_exec(_5416,_5428,_5472,_5422,_5424),(_5472='Prelude.Nothing'->_5420=_5472;(compileWithSharing(variable)->user:propagateShare(_5472,_5420);_5472=_5420),update_mutable('$eval'(_5420),_5412))).
prim_timeoutOnStream_exec(_5648,[],'Prelude.Just'([]),_5654,_5656):-!,_5654=_5656.
prim_timeoutOnStream_exec(_5754,[_5738|_5740],'Prelude.Just'([_5738|_5740]),_5760,_5762):-!,_5760=_5762.
prim_timeoutOnStream_exec(_5848,'Ports.basicServerLoop'(_5844),_5852,_5854,_5856):-(readPort(_5844,_5862,_5848)->(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_5844),_5878);_5878='Ports.basicServerLoop'(_5844)),_5852='Prelude.Just'([_5862|_5878]);_5852='Prelude.Nothing'),_5854=_5856.
send_extvar_binding(_6294,_6296,_6298,_6300):-freeze(_6296,blocked_send_extvar_binding(_6294,_6296,_6298,_6300)).
blocked_send_extvar_binding(_6362,_6364,_6366,_6368):-evalToken(_6372),user:normalizeAndCheck(_6364,_6378,_6372,_6382),user:waitUntilGround(_6378,_6382,_6396),eval_send_extvar_binding(_6362,_6378,_6366,_6396,_6368).
eval_send_extvar_binding(_6798,_6800,_6802,_6804,_6806):-freeze(_6804,blocked_eval_send_extvar_binding(_6798,_6800,_6802,_6804,_6806)).
blocked_eval_send_extvar_binding(nostream,_6878,_6880,_6882,_6884):-writeErr('ERROR: cannot send binding for variable '),writeErr(_6880),writeErr(': '),writeErr(_6878),nlErr,!.
blocked_eval_send_extvar_binding(_7000,_7002,_7004,_7006,_7008):-show4sending(_7002,_7014,_7016),ifTracePort((writeErr('TRACEPORTS: send binding for variable '),writeErr(_7004),writeErr(': '),writeChars(user_error,_7014),nlErr)),number_codes(_7004,_7068),putChars(_7000,[86|_7068]),put_code(_7000,10),writeChars(_7000,_7014),put_code(_7000,10),flush_output(_7000),!,_7008=done.
readPort('Ports.internalPort'(_7232,_7234,_7236,_7238),_7244,_7246):-var(_7238),!,string2Atom(_7232,_7256),writeErr('ERROR: readPort: Port '),writeErr(_7234),writeErr(/),writeErr(_7236),writeErr(@),writeErr(_7256),writeErr(' only opened for writing!'),nlErr.
readPort('Ports.internalPort'(_7398,_7400,_7402,_7404),_7410,_7412):-on_exception(_7426,readFromSocket(_7402,_7404,_7410,_7412),(printError(_7426)->_7410=[];_7410=[])),!.
checkIncomingPortStreams(_7518,_7520,_7522):-retract(incomingPortStreams(_7518,[message(_7520,_7522)|_7534])),asserta(incomingPortStreams(_7518,_7534)),!.
checkIncomingPortStreams(_7620,_7622,_7624):-retract(incomingPortStreams(_7620,[ping(_7628,_7630)|_7636])),asserta(incomingPortStreams(_7620,_7636)),answerPingOnStream(_7628,_7630),checkIncomingPortStreams(_7620,_7622,_7624),!.
answerPingOnStream(_7748,_7750):-write(_7750,ok),put_code(_7750,10),flush_output(_7750),closeSocketStream(_7748,_7750),ifTracePort((writeErr('TRACEPORTS: Ping request answered.'),nlErr)).
readFromSocket(_7856,_7858,_7860,_7862):-checkIncomingPortStreams(_7856,_7868,_7870),!,readStreamLine(_7868,_7876),(parse_received_message(_7868,_7870,_7876,_7860)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_7876),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_7876),nlErr,readFromSocket(_7856,_7858,_7860,_7862)),!.
readFromSocket(_8048,_8050,_8052,_8054):-waitForSocketClientStream(_8050,_8054,_8062,_8064,_8066),ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_8062),nlErr)),(readPortMessage(_8048,_8064,_8066,_8100)->(parse_received_message(_8064,_8066,_8100,_8052)->ifTracePort((writeErr('TRACEPORTS: Received message: '),putChars(user_error,_8100),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_8100),nlErr,readFromSocket(_8048,_8050,_8052,_8054));readFromSocket(_8048,_8050,_8052,_8054)),!.
readFromSocket(_8288,_8290,_8292,_8294):-ifTracePort((writeErr('TRACEPORTS: Timeout!'),nlErr)),fail.
readPortMessage(_8376,_8378,_8380,_8382):-readStreamLine(_8378,_8388),_8388=[_8392|_8394],checkMessageHeader(_8392,_8378,_8380,_8410),number_codes(_8414,_8394),!,(_8414=_8376->readPortMessageBody(_8410,_8382);(retract(incomingPortStreams(_8414,_8440))->append(_8440,[_8410],_8458);_8458=[_8410]),asserta(incomingPortStreams(_8414,_8458)),!,fail).
checkMessageHeader(78,_8608,_8610,message(_8608,_8610)):-!.
checkMessageHeader(80,_8682,_8684,ping(_8682,_8684)):-!.
checkMessageHeader(_8756,_8758,_8760,_8762):-writeErr('ERROR: Illegal message header received.'),nlErr,!,fail.
readPortMessageBody(message(_8846,_8848),_8854):-readStreamLine(_8846,_8854).
readPortMessageBody(ping(_8906,_8908),_8914):-answerPingOnStream(_8906,_8908),!,fail.
prim_sendPort(_9216,_9218,_9220,_9222,_9224):-freeze(_9222,blocked_prim_sendPort(_9216,_9218,_9220,_9222,_9224)).
blocked_prim_sendPort(_9294,_9296,_9298,_9300,_9302):-user:derefAll(_9294,_9308),user:derefRoot(_9296,_9320),prim_sendPortExec(_9308,_9320,_9298,_9300,_9302).
prim_sendPortExec(_9430,'Ports.internalPort'(_9420,0,_9424,_9426),'Prelude.True',_9436,_9438):-!,add2Stream(_9426,_9430),_9436=_9438.
prim_sendPortExec('Ports.SP_Put'(_9532),'Ports.internalPort'(_9536,-1,_9540,_9542),'Prelude.True',_9552,_9554):-!,user:waitUntilGround(_9532,_9552,_9554),writeChars(_9542,_9532),nl(_9542),flush_output(_9542),ifTracePort((writeErr('TRACEPORTS: SP_Put: '),writeChars(user_error,_9532),nlErr)).
prim_sendPortExec('Ports.SP_GetLine'(_9708),'Ports.internalPort'(_9712,-1,_9716,_9718),'Prelude.True',_9728,_9730):-!,readStreamLine(_9712,_9736),map2M(basics:char_int,_9748,_9736),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_9748),nlErr)),user:constrEq(_9748,_9708,_9784,_9728,_9730).
prim_sendPortExec('Ports.SP_GetChar'(_9888),'Ports.internalPort'(_9892,-1,_9896,_9898),'Prelude.True',_9908,_9910):-!,get_code(_9892,_9916),char_int(_9916,_9922),ifTracePort((writeErr('TRACEPORTS: SP_GetChar: '),writeErr(_9922),nlErr)),user:constrEq(_9922,_9888,_9954,_9908,_9910).
prim_sendPortExec('Ports.SP_EOF'(_10058),'Ports.internalPort'(_10062,-1,_10066,_10068),'Prelude.True',_10078,_10080):-!,(atEndOfStream(_10062)->_10088='Prelude.True';_10088='Prelude.False'),ifTracePort((writeErr('TRACEPORTS: SP_EOF: '),writeErr(_10088),nlErr)),user:constrEq(_10058,_10088,_10140,_10078,_10080).
prim_sendPortExec('Ports.SP_Close','Ports.internalPort'(_10238,-1,_10242,_10244),'Prelude.True',_10254,_10256):-!,close(_10244),close(_10238),_10254=_10256.
prim_sendPortExec(_10368,'Ports.internalPort'(_10358,-1,_10362,_10364),'Prelude.True',_10374,_10376):-!,writeErr('ERROR: wrong message received by stream port: '),writeErr(_10368),nlErr,_10374=_10376.
prim_sendPortExec(_10494,'Ports.internalPort'(_10484,_10486,_10488,_10490),'Prelude.True',_10500,_10502):-string2Atom(_10484,_10508),on_exception(_10542,send2Socket(_10508,_10486,_10488,_10494),(write('ERROR: send to port '),write(_10488),write(@),write(_10508),write(:),nl,(printError(_10542)->true;true))),_10500=_10502.
add2Stream(_10686,_10688):-var(_10686),!,_10686=[_10688|_10698].
add2Stream([],_10764):-write('ERROR: send: stream has not a free variable at the end'),nl.
add2Stream([_10820|_10822],_10828):-add2Stream(_10822,_10828).
prim_ping(_10894,'Ports.internalPort'(_10880,0,_10884,_10886),'Prelude.Just'(0)):-!.
prim_ping(_10966,'Ports.internalPort'(_10952,-1,_10956,_10958),'Prelude.Just'(0)):-!.
prim_ping(_11034,'Ports.internalPort'(_11024,_11026,_11028,_11030),_11038):-string2Atom(_11024,_11044),on_exception(_11066,ping2SocketPort(_11044,_11026,_11028,_11034,_11038),_11038='Prelude.Nothing').
ping2SocketPort(_11130,_11132,_11134,_11136,_11138):-connect2socket(_11130,_11132,_11146,_11148),number_codes(_11134,_11154),putChars(_11148,[80|_11154]),put_code(_11148,10),flush_output(_11148),getElapsedTime(_11180),ifTracePort((writeErr('TRACEPORTS: Ping to "'),writeErr(_11132),writeErr(/),writeErr(_11134),writeErr(@),writeErr(_11130),writeErr('"'),nlErr)),waitForInputDataOnStreams([_11146],_11136,_11268),(_11268=0->readStreamLine(_11146,_11280),closeSocketStream(_11146,_11148),getElapsedTime(_11290),_11300 is _11290-_11180,ifTracePort((writeErr('TRACEPORTS: Ping answer received in '),writeErr(_11300),writeErr(' ms'),nlErr)),_11138='Prelude.Just'(_11300);ifTracePort((writeErr('TRACEPORTS: No ping answer received'),nlErr)),_11138='Prelude.Nothing').
prim_connectPortAtSocket(_11542,_11544,_11546,'Ports.internalPort'(_11532,_11534,_11536,'Prelude.()')):-user:derefRoot(_11542,_11534),user:derefRoot(_11544,_11536),user:derefAll(_11546,_11532),!.
send2Socket(_11664,_11666,_11668,_11670):-connect2socket(_11664,_11666,_11678,_11680),number_codes(_11668,_11686),putChars(_11680,[78|_11686]),put_code(_11680,10),show4sending(_11670,_11710,_11712),writeChars(_11680,_11710),put_code(_11680,10),flush_output(_11680),ifTracePort((writeErr('TRACEPORTS: Sent to "'),writeErr(_11666),writeErr(/),writeErr(_11668),writeErr(@),writeErr(_11664),writeErr('": '),writeChars(user_error,_11710),nlErr)),rev(_11712,_11820),receive_extvar_bindings(_11678,_11820).
receive_extvar_bindings(_11948,[]):-!,ifTracePort((writeErr('TRACEPORTS: Closing send-connection'),nlErr)),close(_11948).
receive_extvar_bindings(_12026,_12028):-readStreamLine(_12026,_12034),_12034=[86|_12040],number_codes(_12050,_12040),readStreamLine(_12026,_12058),(deleteIndexVariable(_12050,_12028,_12066,_12068)->true;writeErr('ERROR: Illegal binding for logical variable received:'),nlErr,_12068=_12028),(parse_received_message(nostream,nostream,_12058,_12112)->ifTracePort((writeErr('TRACEPORTS: Received binding for variable '),writeErr(_12050),writeErr(': '),putChars(user_error,_12058),nlErr));writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_12058),nlErr),!,_12066=_12112,receive_extvar_bindings(_12026,_12068).
show4sending(_12298,_12300,_12302):-numberVars(_12298,_12308,[],_12302),show_term(_12308,qualified,_12300,[]).
getVariableIndex(_12394,[(_12382,_12384)|_12390],_12384):-_12394==_12382,!.
getVariableIndex(_12470,[_12464|_12466],_12474):-getVariableIndex(_12470,_12466,_12474).
getIndexVariable(_12538,[(_12536,_12538)|_12544],_12536):-!.
getIndexVariable(_12612,[_12606|_12608],_12616):-getIndexVariable(_12612,_12608,_12616).
deleteIndexVariable(_12680,[(_12678,_12680)|_12686],_12678,_12686):-!.
deleteIndexVariable(_12770,[_12758|_12760],_12774,[_12758|_12766]):-deleteIndexVariable(_12770,_12760,_12774,_12766).
parse_received_message(_12848,_12850,_12852,_12854):-readTerm(_12852,qualified,_12862,_12864),skipWhiteSpace(_12862,[]),extractVars(_12864,_12854,[],_12880),send_extvar_bindings(_12880,_12886,_12850),closeStreamAfterDones(_12886,_12848,_12850).
send_extvar_bindings([],[],_12986).
send_extvar_bindings([(_13028,_13030)|_13036],[_13040|_13042],_13050):-send_extvar_binding(_13050,_13028,_13030,_13040),send_extvar_bindings(_13036,_13042,_13050).
closeStreamAfterDones([],nostream,_13132):-!.
closeStreamAfterDones([],_13188,_13190):-ifTracePort((writeErr('TRACEPORTS: Closing receive-connection'),nlErr)),closeSocketStream(_13188,_13190).
closeStreamAfterDones([_13270|_13272],_13278,_13280):-closeStreamAfterDones(_13270,_13272,_13278,_13280).
closeStreamAfterDones(_13628,_13630,_13632,_13634):-freeze(_13628,blocked_closeStreamAfterDones(_13628,_13630,_13632,_13634)).
blocked_closeStreamAfterDones(_13696,_13698,_13700,_13702):-closeStreamAfterDones(_13698,_13700,_13702).
prim_openProcessPort(_13782,'Ports.internalPort'(_13772,-1,0,_13778)):-user:derefAll(_13782,_13790),string2Atom(_13790,_13802),execCommand(_13802,_13778,_13772,_13812).
prim_choiceSPEP(_14162,_14164,_14166,_14168,_14170):-freeze(_14164,freeze(_14168,blocked_prim_choiceSPEP(_14162,_14164,_14166,_14168,_14170))).
blocked_prim_choiceSPEP(_14246,_14248,_14250,_14252,_14254):-user:derefRoot(_14246,_14260),prim_choiceSPEP_exec(_14260,_14248,_14250,_14252,_14254).
prim_choiceSPEP_exec(_14358,share(_14354),_14362,_14364,_14366):-!,get_mutable(_14370,_14354),(_14370='$eval'(_14376)->_14364=_14366,_14362='Prelude.Right'(_14376);prim_choiceSPEP_exec(_14358,_14370,_14418,_14364,_14366),(_14418='Prelude.Left'(_14426)->_14362=_14418;_14418='Prelude.Right'(_14448),(compileWithSharing(variable)->user:propagateShare(_14448,_14464);_14448=_14464),_14362='Prelude.Right'(_14464),update_mutable('$eval'(_14464),_14354))).
prim_choiceSPEP_exec(_14642,[_14626|_14628],'Prelude.Right'([_14626|_14628]),_14648,_14650):-!,_14648=_14650.
prim_choiceSPEP_exec('Ports.internalPort'(_14732,-1,_14736,_14738),[],_14746,_14748,_14750):-readStreamLine(_14732,_14756),map2M(basics:char_int,_14768,_14756),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_14768),nlErr)),_14746='Prelude.Left'(_14768),_14748=_14750,!.
prim_choiceSPEP_exec(_14916,'Ports.basicServerLoop'(_14912),_14920,_14922,_14924):-_14912='Ports.internalPort'(_14928,_14930,_14932,_14934),checkIncomingPortStreams(_14932,_14946,_14948),!,readStreamLine(_14946,_14954),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_14912),_14968);_14968='Ports.basicServerLoop'(_14912)),(parse_received_message(_14946,_14948,_14954,_15000)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_15000),nlErr)),_14920='Prelude.Right'([_15000|_14968]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_14954),nlErr,prim_choiceSPEP_exec(_14916,_14968,_14920,_14922,_14924)),_14922=_14924,!.
prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_96,_98),'Ports.basicServerLoop'(_102),_110,_112,_114):-_102='Ports.internalPort'(_118,_120,_122,_124),waitForSocketOrInputStreams(_124,_142,_144,_146,[_92],_150),(compileWithSharing(function)->makeShare('Ports.basicServerLoop'(_102),_164);_164='Ports.basicServerLoop'(_102)),(_142=no->readStreamLine(_92,_198),map2M(basics:char_int,_210,_198),ifTracePort((writeErr('TRACEPORTS: SP_Get: '),writeChars(user_error,_210),nlErr)),_110='Prelude.Left'(_210);ifTracePort((writeErr('TRACEPORTS: Connection to client: '),writeErr(_142),nlErr)),(readPortMessage(_122,_144,_146,_306)->(parse_received_message(_144,_146,_306,_316)->ifTracePort((writeErr('TRACEPORTS: Received message: '),writeErr(_316),nlErr)),_110='Prelude.Right'([_316|_164]);writeErr('ERROR: Illegal message received (ignored): '),putChars(user_error,_306),nlErr,prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_386,_98),_164,_110,_112,_114));prim_choiceSPEP_exec('Ports.internalPort'(_92,-1,_438,_98),_164,_110,_112,_114))),_112=_114,!.
numberVars(_580,'VAR'(_576),_584,_586):-var(_580),!,(getVariableIndex(_580,_584,_576)->_586=_584;length(_584,_576),_586=[(_580,_576)|_584]).
numberVars(_720,_722,_724,_726):-isShowableArg(_720),_720=..[_734|_736],numberVarsList(_736,_748,_724,_726),_722=..[_734|_748].
numberVarsList([],[],_848,_848).
numberVarsList([_900|_902],[_906|_908],_916,_918):-numberVars(_900,_906,_916,_928),numberVarsList(_902,_908,_928,_918).
extractVars(_1006,_1006,_1010,_1010):-var(_1006),!.
extractVars('VAR'(_1084),_1090,_1092,_1094):-!,(getIndexVariable(_1084,_1092,_1090)->_1094=_1092;_1094=[(_1090,_1084)|_1092]).
extractVars(_1206,_1208,_1210,_1212):-_1206=..[_1216|_1218],extractVarsList(_1218,_1230,_1210,_1212),_1208=..[_1216|_1230].
extractVarsList([],[],_1324,_1324).
extractVarsList([_1376|_1378],[_1382|_1384],_1392,_1394):-extractVars(_1376,_1382,_1392,_1404),extractVarsList(_1378,_1384,_1404,_1394).
prim_after(_1700,_1702,_1704,_1706):-freeze(_1704,blocked_prim_after(_1700,_1702,_1704,_1706)).
blocked_prim_after(_1768,_1770,_1772,_1772):-raise_exception('Ports.after not implemented!').
